/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef AGENTSERVICECLIENT_H_
#define AGENTSERVICECLIENT_H_

#include <string>
#include <iostream>
#include "ClientContext.h"
#include "AgentDiscoveryResponse.h"
#include "MessageCreator.h"
#include "ClientCall.h"
#include "NBCCoverMessage.h"
#include "SecurityUtil.h"
#include "ServiceException.h"

#include <iostream>
#include <string>
#include <vector>


using namespace std;

class AgentServiceClient
{
	public:
		virtual ~AgentServiceClient();	
		 AgentServiceClient(string);	
		void init();
		AgentDiscoveryResponse *discoverAgentFIFO();
		vector<string> discoverServices(AgentDiscoveryResponse *discoveryResponse);
		
		
	private:
	
		int getCoverMessages(char **responses,int num_res,NBCCoverMessage *coverMsgs[]);
		AgentDiscoveryResponse *selectAgentFIFO(NBCCoverMessage *coverMsgs[],int numReturned);
		
		/** These should go to a config file under policies */
		static const int ONE_RESPONSE = 1;
		
		string configFile;
		ClientContext ctx;
		ClientCall call;
		MessageCreator msgCreator;
		SecurityUtil secUtil;
		UserRSA *rsa;
};

#endif /*AGENTSERVICECLIENT_H_*/
