/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef CLIENTCONTEXT_H_
#define CLIENTCONTEXT_H_

#include <string>
#include <iostream>
#include "UserRSA.h"
#include "constants.h"

using namespace std;

class ClientContext{

public:
	ClientContext();
	~ClientContext();
	
	void setBrokerPort(int brokerPort );	
	int getBrokerPort();		
	void setBrokerHost(string brokerHost);		
	string getBrokerHost();		
	void setBrokerTransport(string brokerTransport);		
	string getBrokerTransport();		
	void setKeystoreFile(string keyStoreFile);		
	string getKeystoreFile();		
	void setKeystorePwd(string keyStorePwd);		
	string getKeystorePwd();		
	void setKeyAlias(string keyAlias);		
	string getKeyAlias();		
	void setPrivateKeyPwd(string privateKeyPwd);		
	string getPrivateKeyPwd();		
	void setEntityId(int entityId);		
	int getEntityId();		
	void setTrustedCAs(string trustedCAs);	
	string getTrustedCAs();	
	void setProxyFile(string proxyFile);		
	string getProxyFile();		
	void display();
	
	void setUserRSA(UserRSA * rsa);
	UserRSA *getUserRSA();
	
	
private:
	string brokerHost;
	int brokerPort;
	string brokerTransport;
	string keyStoreFile;
	string keyStorePwd;
	string keyAlias;
	string privateKeyPwd;
	int entityId;	
	string trustedCAs;
	string proxyFile;
	
	UserRSA *uRsa;
	

//	 UUIDGenerator uuidGen;
//
//	 X509Certificate ownerCert;
//
//	 PrivateKey ownerPrivateKey;
//
//	 SecurityUtil secUtil;
//
//	 KeystoreManager km;
//
//	 ClarensContext ctx;
//
//	 MessageCreator msgCreator;
//
//	 ClientCall call;

};

#endif /*CLIENTCONTEXT_H_*/
