/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef NBCCOVERMESSAGE_H_
#define NBCCOVERMESSAGE_H_

#include <string>
#include <iostream>
#include "NBCMessage.h"

using namespace std;

class NBCCoverMessage :public NBCMessage
{
	public:
		NBCCoverMessage();
		~NBCCoverMessage();
			
		string getActionId() {
			return actionId;
		}
	
		void setActionId(string actionId) {
			this->actionId = actionId;
			hasActionId = true;
		}
	
		 char getActionType() {
			return actionType;
		}
	
		 void setActionType(char actionType) {
			this->actionType = actionType;
			hasActionType = true;
		}
	
		 string getCommTopic() {
			return commTopic;
		}
	
		 void setCommTopic(string commTopic) {
			this->commTopic = commTopic;
			hasCommTopic = true;
		}
	
		 string getCorrelationId() {
			return correlationId;
		}
	
		 void setCorrelationId(string correlationId) {
			this->correlationId = correlationId;
			hasCorrelationId = true;
		}
	
		 char getDataType() {
			return dataType;
		}
	
		 void setDataType(char dataType) {
			this->dataType = dataType;
		}
	
		 char getExchangeType() {
			return exchangeType;
		}
	
		 void setExchangeType(char exchangeType) {
			this->exchangeType = exchangeType;
			hasExchangeType = true;
		}	

        NBCMessage *getPayloadMessage() {
			return payloadMessage;
		}
	
		 void setPayloadMessage(NBCMessage *payloadMessage) {
			this->payloadMessage = payloadMessage;
			this->hasPayloadMessage = true;
		}
	
		 bool isHasActionId() {
			return hasActionId;
		}
	
		 bool isHasActionType() {
			return hasActionType;
		}
	
		 bool isHasCommTopic() {
			return hasCommTopic;
		}
	
		 bool isHasCorrelationId() {
			return hasCorrelationId;
		}
	
		 bool isHasExchangeType() {
			return hasExchangeType;
		}
	
		 bool isHasPayloadMessage() {
			return hasPayloadMessage;
		}
			
			
		bool fromBytes(char *bytes);
			
		/** Get a byte stream representation of the event */
	  	void getBytes(char *buff,int *length);
	  	
	  	int getSerializedLength();	
			
	private:
	
		const static int NUM_OF_BYTES_FOR_MESSAGE_HEADERS = 256;
		
		char dataType;
		char exchangeType;
		bool hasExchangeType;
		char actionType;
		bool hasActionType;
		
		/* 128 bit UUID */
		string actionId;
		bool hasActionId;
		string correlationId;
		bool hasCorrelationId;
		string commTopic;
		bool hasCommTopic;
	
		/* Protocol messages */
		NBCMessage *payloadMessage;
		bool hasPayloadMessage;
		
		bool deletable;

};


#endif /*NBCCOVERMESSAGE_H_*/
