/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef SECURITYUTIL_
#define SECURITYUTIL_

#include <iostream>
#include <string>
#include "openssl/rsa.h"
#include "openssl/evp.h"

#include "SecurityUtil.h"

#include "NBCEnvelope.h"
#include "SecurityException.h"

class SecurityUtil{
	public:
		SecurityUtil();
		~SecurityUtil();
		void init();
		bool verifySignature(NBCEnvelope &env);
		char *signBytes(char * bytes,unsigned int size, RSA  *privateRSA,int *sig_size);
		string generateAESKey();
		bool encryptAES(const unsigned char *in,int inputLength ,unsigned char *out,int &outputLength, string aesKey);
		bool decryptAES(const unsigned char *in,int inputLength ,unsigned char *out,int &outputLength, string aesKey);
			
		
	private:
		EVP_MD_CTX vctx;

};

#endif /*SECURITYUTIL_*/
