/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#ifndef CLARENS_Cpp_CLIENT_USER_RSA_H
#define CLARENS_Cpp_CLIENT_USER_RSA_H
#include "openssl/rsa.h"
#include "openssl/evp.h"
#include <string>
using namespace std;
class UserRSA{
   public:
      static UserRSA* getUserRSA(const string& cert, const string& key);
      static UserRSA* getUserRSA(const string& proxy);
      static UserRSA* getUserRSA();
      const RSA* getPrivateRSA() const;
      const RSA* getPublicRSA() const;
       string getUserCert() ;
       char* getUserDN() ;
      const string& error() const;
      bool isInitialized() const;
      void ref ();
      void unref();
      
   private:
      UserRSA (const string& proxy);
      UserRSA (const string& cert, const string& key);
      ~UserRSA();
      bool init(string cert, string key);
      bool init(string proxy);
      void SSLInit();
      static int passPhraseInput (char* buf,int size,int rwflag,void* object);
      
      
      
      static UserRSA* m_self;
      RSA*            m_userPrivateRSA;
      RSA*            m_userPublicRSA;
      string          m_cert ;
      string          m_userDN ;
      string          m_error ;
      bool            m_initialized;
      int             m_ref;
 };
 
 #endif
      
      
