/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include "ServiceClient.h"
#include "Profile.h"
#include "Utils.h"

using namespace std;

#define PRINT_COUNT 500
#define TO_MILLIS 1000


class MyCallback : public Callback
{
	public:
	MyCallback()
		:totalTime(0),count(0)
	{}
	
	void onEvent(NBEvent *nbEvent){
		count++;
		//Get the time in the payload.
		char * payload=nbEvent->getContentPayload();
		int length=nbEvent->getPayloadLength();
				
		long long offset=0;
		long long time=Utils::readLong(payload,offset);
		cout<<"Time = "<<time<<endl;
		delete[] payload;
		
		//string msg(payload+offset,length-offset);
		//cout<<"Message = "<<msg<<endl;		
	
		//Convert it to long long		
		//long long time=atoll(payload); // Alternative std::istringstream ss_port(*argv++); ss_port >> port;  
		//Get the current time
		long long curTime=Utils::getCurrentTimeMicroseconds();
		//Time difference in micro seconds
		long long diffmicro=(curTime-time);	
		//Add the diffmicro for PRINT_COUNT times to increase accuracy
		totalTime+=diffmicro;		
		if(count%PRINT_COUNT==0){
			long long millis=totalTime/TO_MILLIS;
			cout<<millis<<endl;
			totalTime=0;
		}		
	}
	
	private:
		long long totalTime;
	    int count;
};



int main(int argc, char **argv){
	cout<<"///////////////////////BMReceiver////////////////////////"<<endl;

	if(argc!=5){
		cout<<"Usage : [host][port][entityId][topic]"<<endl;
		exit(1);	
	}
	/*Ignore the first argument */
	*argv++;	
	string host=*argv++;
	int port=5045;
	std::istringstream ss_port(*argv++);
	ss_port >> port;	
	
	int entityId=0;
	std::istringstream ss(*argv++);
    ss >> entityId;
	string contentSynopsis=*argv++;
	
	if(entityId<=0|| contentSynopsis.length()<=0){
		cout<<"Usage : [host][port][entityId][topic]"<<endl;
		exit(1);	
	}
	
	
	int templateId=55745;
			
	ServiceClient serviceClient;
	serviceClient.init(host,port,entityId,templateId);
	
	MyCallback callback;
	serviceClient.subscribe(contentSynopsis,&callback);
	cout<<"====================Benchmark Receiver============="<<endl;
	cout<<"Type any number of messages and <return key>"<<endl;
	cout<<"To exit type .<return key>"<<endl;
	cout<<"==================================================="<<endl;
	
	char msg[256]="";
	string str="";
	while (str!="."){
        cin.getline(msg, 256);
		str=msg;
		if(!(str==".")){
			cout<<"Invalid input. To exit type .<return key>"<<endl;
		}
	}
	
	serviceClient.cleanup();
	
}
