/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "ClarensCallback.h"
#include "TROOT.h"
#include "TSystem.h"
#include "Api.h"
#include "TString.h"

#include "Class.h"
#include "BaseCls.h"
#include "Type.h"
#include "Method.h"
#include "MethodAr.h"
#include "DataMbr.h"
#include "CallFunc.h"
#include "Typedf.h"

ClarensCallback::ClarensCallback(TCallback *tCallback):tCallback(tCallback){

}

ClarensCallback::~ClarensCallback(){
	
}

void
ClarensCallback::onEvent(NBEvent *nbEvent){
	cerr<<"----------Event Rececived with the following information---------- "<<endl;
	cerr<<"Topic  = "<<nbEvent->getContentSynopsis()<<endl;
	char * payload=nbEvent->getContentPayload();
	int payloadSize=nbEvent->getPayloadLength();
	
	///Call the callback function using the reflection mechanism provided by the ROOT
	G__CallFunc func;
	G__ClassInfo cl(this->tCallback->getClassName().c_str());
	
	Long_t offset;	
	char temp[128];
	sprintf(temp,"(void **)%-p,(char *)%-p,(int)%d",this->tCallback->getArgs(),payload,payloadSize);
		
	int error=0;
	
	func.SetFunc(&cl,this->tCallback->getMethodName().c_str(),temp,&offset);
	func.Exec(0);
	
	if(error) error=G__lasterror();

}

