/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "EncryptedCoverMessage.h"
#include "constants.h"
#include "Utils.h"

EncryptedCoverMessage::EncryptedCoverMessage():deletable(false){}
EncryptedCoverMessage::~EncryptedCoverMessage(){
	if(deletable){
		delete [] this->message;
		delete [] this->secretKey;
	}
}


int
EncryptedCoverMessage::getSerializedLength(){
	return HEADER_SIZE+this->messageLength+this->secretKeyLength;	
}	

bool
EncryptedCoverMessage::fromBytes(char *bytes){
	 this->deletable=true;
	 long long offset = 0;
 	  	
 	/*Validate the first two bytes*/
 	if(CLARENS_DATA!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	if(NB_CLARENS_MESSAGE!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	
	/*Reading message*/
	this->messageLength = Utils::readInt(bytes+offset,offset);
	
	this->message=new char[messageLength];
	Utils::copyBytes((bytes+offset),this->message,messageLength,offset);
		 
	/*Reading Encrypted SecretKey*/
	this->secretKeyLength = Utils::readInt(bytes+offset,offset);
	
	this->secretKey=new char[secretKeyLength];
	Utils::copyBytes((bytes+offset),this->secretKey,secretKeyLength,offset);	
	return true;
}

void
EncryptedCoverMessage::getBytes(char *buff,int *length){
	 long long offset = 0;
	 /*Headerse*/
	 Utils::writeByte(buff+offset,(char)CLARENS_DATA,offset);
     Utils::writeByte(buff+offset,(char)NB_CLARENS_MESSAGE,offset);
     
     /*Payload*/
   	 //cout<<"Writing payload ="<<payload_length<<endl;     
     Utils::writeInt(buff+offset,this->messageLength,offset);
     Utils::writeBytes(buff+offset,message,this->messageLength,offset);
     
     /*SecretKey*/
     //cout<<"Writing Encrypted secretKey ="<<this->secretKey<<endl;     
     Utils::writeInt(buff+offset,this->secretKeyLength,offset);
     Utils::writeBytes(buff+offset,secretKey,this->secretKeyLength,offset);

     //Now set the length
     (*length)=offset;          
}
