/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "ServiceDiscoveryRequest.h"
#include "constants.h"
#include "Utils.h"

ServiceDiscoveryRequest::ServiceDiscoveryRequest(){}

ServiceDiscoveryRequest::~ServiceDiscoveryRequest(){	
}


int 
ServiceDiscoveryRequest::getSerializedLength(){
	int length=SIZE_OF_HEADERS;
	
	length+=requestId.length();
	length+=serviceDescription.length();
	//cout<<"Length of the service Description at ServiceDiscoveryRequest = "<<serviceDescription.length()<<endl;
	return length;
}

void 
ServiceDiscoveryRequest::getBytes(char *buff,int *length)
{
	 long long offset = 0;
	 Utils::writeByte(buff+offset,(char)CLARENS_DATA,offset);
     Utils::writeByte(buff+offset,(char)NB_CLARENS_MESSAGE,offset);
     
     Utils::writeInt(buff+offset,requestId.length(),offset);
     //cout<<"Lenght of the request ID @ AgentDiscoveryRequest::getBytes" <<requestId.length()<<endl;
     Utils::writeBytes(buff+offset,requestId.c_str(),requestId.length(),offset);     
     
     Utils::writeInt(buff+offset,serviceDescription.length(),offset);
     //cout<<"Lenght of the request ID @ AgentDiscoveryRequest::getBytes" <<requestId.length()<<endl;
     Utils::writeBytes(buff+offset,serviceDescription.c_str(),serviceDescription.length(),offset);  
    
     //Now set the length
     (*length)=offset;          

}


bool 
 ServiceDiscoveryRequest::fromBytes(char *bytes){
 	 long long offset = 0;
 	  	
 	//Validate the first two bytes
 	if(CLARENS_DATA!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	if(NB_CLARENS_MESSAGE!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	
	int requestIdLength=Utils::readInt(bytes+offset,offset);
	char id[requestIdLength];
	Utils::copyBytes((bytes+offset),id,requestIdLength,offset);
	this->requestId.assign(id,requestIdLength);
	
	 
	int serviceDescriptionLength=Utils::readInt(bytes+offset,offset);
	char desc[serviceDescriptionLength];
	Utils::copyBytes((bytes+offset),desc,serviceDescriptionLength,offset);
	
	this->serviceDescription.assign(desc,serviceDescriptionLength);	
	return true;
}
