/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include "ServiceDiscoveryResponse.h"
#include "constants.h"
#include "Utils.h"

ServiceDiscoveryResponse::ServiceDiscoveryResponse(){}

ServiceDiscoveryResponse::~ServiceDiscoveryResponse(){	
}


int 
ServiceDiscoveryResponse::getSerializedLength(){
	int length=0;
		
	/*For the number of service descriptions*/
	length+=INT_LENGTH;

	for( vector<string>::iterator iter = serviceDescriptions.begin(); iter != serviceDescriptions.end(); iter++) {
		length+=(*iter).length();
 	}	
	return length;
}

void 
ServiceDiscoveryResponse::getBytes(char *buff,int *length)
{
	long long offset = 0;
	Utils::writeByte(buff+offset,(char)CLARENS_DATA,offset);
    Utils::writeByte(buff+offset,(char)NB_CLARENS_MESSAGE,offset);
    
    //Number of service Descriptions.
    Utils::writeInt(buff+offset,serviceDescriptions.size(),offset);    
     
    for( vector<string>::iterator iter = serviceDescriptions.begin(); iter != serviceDescriptions.end(); iter++) {		
		 Utils::writeInt(buff+offset,(*iter).length(),offset);
    	 //cout<<"Lenght of the request ID @ AgentDiscoveryRequest::getBytes" <<requestId.length()<<endl;
    	 Utils::writeBytes(buff+offset,(*iter).c_str(),(*iter).length(),offset);  		
	}
     
    //Now set the length
    (*length)=offset;
}


bool 
 ServiceDiscoveryResponse::fromBytes(char *bytes){
 	long long offset = 0;
 	  	
 	//Validate the first two bytes
 	if(CLARENS_DATA!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	if(NB_CLARENS_MESSAGE!=Utils::readByte(bytes+offset,offset)) {return false;} ;
	
	int numDescriptions=Utils::readInt(bytes+offset,offset);
	
	cout<<"NUMBER OF DESCRIPTIONS = "<<numDescriptions<<endl;
	for(int i=0;i<numDescriptions;i++){	 
		int serviceDescriptionLength=Utils::readInt(bytes+offset,offset);

		char desc[serviceDescriptionLength];
		Utils::copyBytes((bytes+offset),desc,serviceDescriptionLength,offset);
		string serviceDescription(desc,serviceDescriptionLength);
		//Add it to the vector
		serviceDescriptions.push_back(serviceDescription);		
	}
	return true;
}
