/***************************************************************************
 *  Copyright:http://www.naradabrokering.org/index.html
 *  Author: Jaliya Ekanayake
 *  Email : jaliyae@gmail.com
 ****************************************************************************/
#include <iostream>
#include <string>
#include "ServiceDiscoveryRequest.h"
#include "ServiceDiscoveryResponse.h"

#include "assert.h"


static string description="{service:{name:{value:'TestRootService',name:{operations:{operation:{name:'testOperation',operation:{}}}}}}}";
static string requestId="UUID:AAAA1111BBBB2222DDDD3333";

void testServiceDiscoveryRequest(){	
	ServiceDiscoveryRequest req;
	
	req.setRequestId(requestId);
	req.setServiceDescription(description);
	
	int length;
	char serializedMsg[req.getSerializedLength()];
	req.getBytes(serializedMsg,&length);
	
	ServiceDiscoveryRequest newReq;
	newReq.fromBytes(serializedMsg);
	
	assert(newReq.getRequestId().compare(requestId)==0);
	assert(newReq.getServiceDescription().compare(description)==0);
	cout<<"ServiceDiscoveryRequest Test Passed "<<endl;
}

void testServiceDiscoveryResponse(){
	ServiceDiscoveryResponse res;
	//res.setRequestId(requestId);
	res.addServiceDescription(description);
	res.addServiceDescription(description);
	res.addServiceDescription(description);
	res.addServiceDescription(description);
	res.addServiceDescription(description);
	
	int length;
	char serializedMsg[res.getSerializedLength()];
	res.getBytes(serializedMsg,&length);
	
	ServiceDiscoveryResponse newRes;
	newRes.fromBytes(serializedMsg);
	
	///assert(newRes.getRequestId().compare(requestId)==0);
	
	vector<string> serviceDescriptions=newRes.getServiceDescriptions();
	
	for( vector<string>::iterator iter = serviceDescriptions.begin(); iter != serviceDescriptions.end(); iter++) {		
		assert((*iter).compare(description)==0);
	}	
	cout<<"ServiceDiscoveryResponse Test Passed "<<endl;	
	
}



int main(){
	
	testServiceDiscoveryRequest();
	testServiceDiscoveryResponse();
	
	

	return 0;
}
